Attribute VB_Name = "Functions"
Option Explicit

Public File As String
Public AllPath As Variant
Public Clear As Boolean
Public NameTab() As String

'type pour une reference
Public Type RefType
  Nom As String   'Nom de la reference
  Chem As String  'Chemin de la reference
  Fich As String  'Nom du fichier
End Type

'Declaration pour lire dans un fichier ini
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" _
    (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, _
    ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
    
'Declaration pour recupere le chemin du repertoire systeme  (Chez moi "C:\windows\system32")
Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" ( _
                 ByVal lpBuffer As String, _
                 ByVal nSize As Long) As Long


'declaration pour ouvrir la selection d'un repertoire
Private Const BIF_RETURNONLYFSDIRS = 1
Private Const BIF_DONTGOBELOWDOMAIN = 2

Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, _
    ByVal lpBuffer As String) As Long
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, _
    ByVal lpString2 As String) As Long

Private Type BrowseInfo
    hWndOwner As Long
    pIDLRoot As Long
    pszDisplayName As Long
    lpszTitle As Long
     ulFlags As Long
    lpfnCallback As Long
    lParam As Long
    iImage As Long
End Type


Private Function ReadIni(Section As String, Cle As String, Fichier As String, _
    Optional ValeurParDefaut As String = "") As String

    Dim strReturn As String
    
    strReturn = String(255, 0)
    GetPrivateProfileString Section, Cle, ValeurParDefaut, strReturn, Len(strReturn), Fichier
    ReadIni = Left(strReturn, InStr(strReturn, Chr(0)) - 1)
End Function

'fonction permettant de recupere les info de la reference
Public Sub ReadREF()
    Dim DLL As RefType
    
    DLL.Chem = AllPath(UBound(AllPath) - 1)  ' On recupere le chemn du fichier
    DLL.Chem = Replace(DLL.Chem, "..\", "")
    DLL.Chem = Left(SystemDirectory, 3) & Replace(DLL.Chem, "C:\", "")
    DLL.Nom = AllPath(UBound(AllPath))       ' On recuperele nom du fichier
    AllPath = Split(DLL.Chem, "\")
    DLL.Fich = AllPath(UBound(AllPath))      ' On recupere le fichier avec extention
    
    'On ajoute cette reference dans la liste des fichiers
    If Not Exist(DLL.Fich) Then LoadMSF DLL.Fich, DLL.Chem, DLL.Nom
    
    
    If LCase(Right(DLL.Chem, 3)) = "dll" Then
        DLL.Chem = Mid(DLL.Chem, 1, Len(DLL.Chem) - 3) & "DEP"
        
        'On recherche aussi les fichiers dont depend cette reference
        SearchInDEP DLL.Chem, DLL.Fich
    End If
End Sub
'fonction permettant de recuperer l'ocx
Public Sub ReadOCX()
    Dim DLL As RefType
    
    DLL.Fich = Trim(AllPath(UBound(AllPath)))           'On recupere le fichier de l'objet
    DLL.Chem = SystemDirectory & "\" & DLL.Fich  'Son chemin d'acces
    
    'On ajoute l'objet dans la liste des fichiers
    If Not Exist(DLL.Fich) Then LoadMSF DLL.Fich, DLL.Chem, DLL.Nom
    DLL.Chem = SystemDirectory & "\" & Mid(DLL.Fich, 1, Len(DLL.Fich) - 3) & "DEP"
    
    'On recherche aussi les fichiers dont depend cet objet
    SearchInDEP DLL.Chem, DLL.Fich
End Sub

'Et la procedure la plus importante, celle qui
'cherche les fichiers lies dans les DLL.
Private Sub SearchInDEP(File As String, Section As String)
    Dim i As Integer
    Dim Word As String, Ini As String
    Dim Fich As String, path As String
    Dim lang As String, key As String
    i = 1
    
    Fich = Mid(Section, 1, Len(Section) - 4)     'On recupere le fichier (sans extention)
                                                 'il nous sera utile dans la suite
    Do
        key = "Uses" + Trim(Str(i))          'On genere des cles
        Word = ReadIni(Section, key, File)   'On lit le fichier "file" dans la section "section"
                                             'avec la cle "key", pour trouver les fichiers de
                                             'dependance
            
        'On recupere le chemin du fichier pour pouvoir l'ajouter dans la liste
        path = Mid(File, 1, Len(File) - Len(Section)) & Word
        'Et on l'ajoute dans le liste
        If Not Exist(Word) Then LoadMSF Word, path, Mid(Word, 1, Len(Word) - 4)
        i = i + 1
        
    Loop Until Word = ""
            
        
    'Certain fichier ont des fichiers de dependance selon la langue
    'Cette partie permet donc de retrouver ces fichiers en fonction de la langue
    'choisi dans le combobox Langue
    Select Case ShowDep.Langage.ListIndex
        Case 0: lang = " <000C>"     'Code de langue : Francais
        Case 1: lang = " <0010>"     'Code de langue : Italien
        Case 2: lang = " <0007>"     'Code de langue : Allemand
        'Case 3: lang = " <000A>"     'Code de langue : Espagnol
        'Case 3: lang = " <0011>"     'Code de langue : Japonais
        'etc ...
    End Select
        
    'On recupere le fichier en selon la langue
    Ini = ReadIni(Section & lang, "Uses1", File)
    'Et son chemin d'acces
    path = Mid(File, 1, Len(File) - Len(Section)) & Ini
    'On l'ajoute dans la liste
    If Not Exist(Ini) Then LoadMSF Ini, path, Mid(Ini, 1, Len(Ini) - 4)
End Sub
'Juste, cette fonction permet de verifier qu'un fchier n'existe pas deja dans la liste
'afin d'eviter les doublons
Private Function Exist(Mot As String) As Boolean
    Dim i As Integer
    
    Exist = False
    For i = 0 To ShowDep.ShowDepFile.Rows - 1
        If LCase(Mot) = LCase(ShowDep.ShowDepFile.TextMatrix(i, 0)) Or Mot = "" Then
            Exist = True
            Exit For
        End If
    Next
End Function

'Cette procedure permet de charger un fichier dans la liste des fichier de dependance
Public Sub LoadMSF(Fich As String, path As String, Optional Nom As String)
    Dim Lign As Integer
    
'    If Clear Then
'        Lign = 0
'        Clear = False
'    Else
'        Lign = Lign + 1
'    End If

    Lign = ShowDep.ShowDepFile.Rows
    ShowDep.ShowDepFile.AddItem ""
    ShowDep.ShowDepFile.TextMatrix(Lign, 0) = Fich
   
    ReDim Preserve NameTab(Lign)
    
    If Nom = "" Then
        NameTab(Lign) = Mid(Fich, 1, Len(Fich) - 4)
    Else
        NameTab(Lign) = Nom
    End If
    
    ShowDep.ShowDepFile.TextMatrix(Lign, 1) = path
End Sub

'Cette fonction permet de recupere le chemin du repertoire systeme ("windows\syste32")
'ceci dans le but d'avoir un programme vraiment independant
Public Function SystemDirectory() As String
    Dim stTmp As String, lgTmp As Long
    
    stTmp = Space$(250)
    lgTmp = 251
    GetSystemDirectory stTmp, lgTmp
    SystemDirectory = Split(stTmp, Chr$(0))(0)
End Function
    
'Fonction permettant la selection d'un repertoire, pour faire la copie des fichiers
Public Function SelectFolder(Titre As String, Handle As Long) As String
    Dim lpIDList As Long
    Dim strBuffer As String
    Dim strTitre As String
    Dim tBrowseInfo As BrowseInfo

    strTitre = Titre
    With tBrowseInfo
        .hWndOwner = Handle
        .lpszTitle = lstrcat(strTitre, "")
        .ulFlags = BIF_RETURNONLYFSDIRS + BIF_DONTGOBELOWDOMAIN
    End With

    lpIDList = SHBrowseForFolder(tBrowseInfo)

    If (lpIDList) Then
        strBuffer = String(260, vbNullChar)
        SHGetPathFromIDList lpIDList, strBuffer
        SelectFolder = Left(strBuffer, InStr(strBuffer, vbNullChar) - 1)
    End If
End Function

